xref: /openbmc/linux/scripts/faddr2line (revision 62257638)
1#!/bin/bash
2# SPDX-License-Identifier: GPL-2.0
3#
4# Translate stack dump function offsets.
5#
6# addr2line doesn't work with KASLR addresses.  This works similarly to
7# addr2line, but instead takes the 'func+0x123' format as input:
8#
9#   $ ./scripts/faddr2line ~/k/vmlinux meminfo_proc_show+0x5/0x568
10#   meminfo_proc_show+0x5/0x568:
11#   meminfo_proc_show at fs/proc/meminfo.c:27
12#
13# If the address is part of an inlined function, the full inline call chain is
14# printed:
15#
16#   $ ./scripts/faddr2line ~/k/vmlinux native_write_msr+0x6/0x27
17#   native_write_msr+0x6/0x27:
18#   arch_static_branch at arch/x86/include/asm/msr.h:121
19#    (inlined by) static_key_false at include/linux/jump_label.h:125
20#    (inlined by) native_write_msr at arch/x86/include/asm/msr.h:125
21#
22# The function size after the '/' in the input is optional, but recommended.
23# It's used to help disambiguate any duplicate symbol names, which can occur
24# rarely.  If the size is omitted for a duplicate symbol then it's possible for
25# multiple code sites to be printed:
26#
27#   $ ./scripts/faddr2line ~/k/vmlinux raw_ioctl+0x5
28#   raw_ioctl+0x5/0x20:
29#   raw_ioctl at drivers/char/raw.c:122
30#
31#   raw_ioctl+0x5/0xb1:
32#   raw_ioctl at net/ipv4/raw.c:876
33#
34# Multiple addresses can be specified on a single command line:
35#
36#   $ ./scripts/faddr2line ~/k/vmlinux type_show+0x10/45 free_reserved_area+0x90
37#   type_show+0x10/0x2d:
38#   type_show at drivers/video/backlight/backlight.c:213
39#
40#   free_reserved_area+0x90/0x123:
41#   free_reserved_area at mm/page_alloc.c:6429 (discriminator 2)
42
43
44set -o errexit
45set -o nounset
46
47usage() {
48	echo "usage: faddr2line [--list] <object file> <func+offset> <func+offset>..." >&2
49	exit 1
50}
51
52warn() {
53	echo "$1" >&2
54}
55
56die() {
57	echo "ERROR: $1" >&2
58	exit 1
59}
60
61READELF="${CROSS_COMPILE:-}readelf"
62ADDR2LINE="${CROSS_COMPILE:-}addr2line"
63AWK="awk"
64
65command -v ${AWK} >/dev/null 2>&1 || die "${AWK} isn't installed"
66command -v ${READELF} >/dev/null 2>&1 || die "${READELF} isn't installed"
67command -v ${ADDR2LINE} >/dev/null 2>&1 || die "${ADDR2LINE} isn't installed"
68
69# Try to figure out the source directory prefix so we can remove it from the
70# addr2line output.  HACK ALERT: This assumes that start_kernel() is in
71# init/main.c!  This only works for vmlinux.  Otherwise it falls back to
72# printing the absolute path.
73find_dir_prefix() {
74	local objfile=$1
75
76	local start_kernel_addr=$(${READELF} --symbols --wide $objfile | ${AWK} '$8 == "start_kernel" {printf "0x%s", $2}')
77	[[ -z $start_kernel_addr ]] && return
78
79	local file_line=$(${ADDR2LINE} -e $objfile $start_kernel_addr)
80	[[ -z $file_line ]] && return
81
82	local prefix=${file_line%init/main.c:*}
83	if [[ -z $prefix ]] || [[ $prefix = $file_line ]]; then
84		return
85	fi
86
87	DIR_PREFIX=$prefix
88	return 0
89}
90
91__faddr2line() {
92	local objfile=$1
93	local func_addr=$2
94	local dir_prefix=$3
95	local print_warnings=$4
96
97	local sym_name=${func_addr%+*}
98	local offset=${func_addr#*+}
99	offset=${offset%/*}
100	local user_size=
101	[[ $func_addr =~ "/" ]] && user_size=${func_addr#*/}
102
103	if [[ -z $sym_name ]] || [[ -z $offset ]] || [[ $sym_name = $func_addr ]]; then
104		warn "bad func+offset $func_addr"
105		DONE=1
106		return
107	fi
108
109	# Go through each of the object's symbols which match the func name.
110	# In rare cases there might be duplicates, in which case we print all
111	# matches.
112	while read line; do
113		local fields=($line)
114		local sym_addr=0x${fields[1]}
115		local sym_elf_size=${fields[2]}
116		local sym_sec=${fields[6]}
117
118		# Get the section size:
119		local sec_size=$(${READELF} --section-headers --wide $objfile |
120			sed 's/\[ /\[/' |
121			${AWK} -v sec=$sym_sec '$1 == "[" sec "]" { print "0x" $6; exit }')
122
123		if [[ -z $sec_size ]]; then
124			warn "bad section size: section: $sym_sec"
125			DONE=1
126			return
127		fi
128
129		# Calculate the symbol size.
130		#
131		# Unfortunately we can't use the ELF size, because kallsyms
132		# also includes the padding bytes in its size calculation.  For
133		# kallsyms, the size calculation is the distance between the
134		# symbol and the next symbol in a sorted list.
135		local sym_size
136		local cur_sym_addr
137		local found=0
138		while read line; do
139			local fields=($line)
140			cur_sym_addr=0x${fields[1]}
141			local cur_sym_elf_size=${fields[2]}
142			local cur_sym_name=${fields[7]:-}
143
144			if [[ $cur_sym_addr = $sym_addr ]] &&
145			   [[ $cur_sym_elf_size = $sym_elf_size ]] &&
146			   [[ $cur_sym_name = $sym_name ]]; then
147				found=1
148				continue
149			fi
150
151			if [[ $found = 1 ]]; then
152				sym_size=$(($cur_sym_addr - $sym_addr))
153				[[ $sym_size -lt $sym_elf_size ]] && continue;
154				found=2
155				break
156			fi
157		done < <(${READELF} --symbols --wide $objfile | ${AWK} -v sec=$sym_sec '$7 == sec' | sort --key=2)
158
159		if [[ $found = 0 ]]; then
160			warn "can't find symbol: sym_name: $sym_name sym_sec: $sym_sec sym_addr: $sym_addr sym_elf_size: $sym_elf_size"
161			DONE=1
162			return
163		fi
164
165		# If nothing was found after the symbol, assume it's the last
166		# symbol in the section.
167		[[ $found = 1 ]] && sym_size=$(($sec_size - $sym_addr))
168
169		if [[ -z $sym_size ]] || [[ $sym_size -le 0 ]]; then
170			warn "bad symbol size: sym_addr: $sym_addr cur_sym_addr: $cur_sym_addr"
171			DONE=1
172			return
173		fi
174
175		sym_size=0x$(printf %x $sym_size)
176
177		# Calculate the section address from user-supplied offset:
178		local addr=$(($sym_addr + $offset))
179		if [[ -z $addr ]] || [[ $addr = 0 ]]; then
180			warn "bad address: $sym_addr + $offset"
181			DONE=1
182			return
183		fi
184		addr=0x$(printf %x $addr)
185
186		# If the user provided a size, make sure it matches the symbol's size:
187		if [[ -n $user_size ]] && [[ $user_size -ne $sym_size ]]; then
188			[[ $print_warnings = 1 ]] &&
189				echo "skipping $sym_name address at $addr due to size mismatch ($user_size != $sym_size)"
190			continue;
191		fi
192
193		# Make sure the provided offset is within the symbol's range:
194		if [[ $offset -gt $sym_size ]]; then
195			[[ $print_warnings = 1 ]] &&
196				echo "skipping $sym_name address at $addr due to size mismatch ($offset > $sym_size)"
197			continue
198		fi
199
200		# In case of duplicates or multiple addresses specified on the
201		# cmdline, separate multiple entries with a blank line:
202		[[ $FIRST = 0 ]] && echo
203		FIRST=0
204
205		echo "$sym_name+$offset/$sym_size:"
206
207		# Pass section address to addr2line and strip absolute paths
208		# from the output:
209		local output=$(${ADDR2LINE} -fpie $objfile $addr | sed "s; $dir_prefix\(\./\)*; ;")
210		[[ -z $output ]] && continue
211
212		# Default output (non --list):
213		if [[ $LIST = 0 ]]; then
214			echo "$output" | while read -r line
215			do
216				echo $line
217			done
218			DONE=1;
219			continue
220		fi
221
222		# For --list, show each line with its corresponding source code:
223		echo "$output" | while read -r line
224		do
225			echo
226			echo $line
227			n=$(echo $line | sed 's/.*:\([0-9]\+\).*/\1/g')
228			n1=$[$n-5]
229			n2=$[$n+5]
230			f=$(echo $line | sed 's/.*at \(.\+\):.*/\1/g')
231			${AWK} 'NR>=strtonum("'$n1'") && NR<=strtonum("'$n2'") { if (NR=='$n') printf(">%d<", NR); else printf(" %d ", NR); printf("\t%s\n", $0)}' $f
232		done
233
234		DONE=1
235
236	done < <(${READELF} --symbols --wide $objfile | ${AWK} -v fn=$sym_name '$4 == "FUNC" && $8 == fn')
237}
238
239[[ $# -lt 2 ]] && usage
240
241objfile=$1
242
243LIST=0
244[[ "$objfile" == "--list" ]] && LIST=1 && shift && objfile=$1
245
246[[ ! -f $objfile ]] && die "can't find objfile $objfile"
247shift
248
249DIR_PREFIX=supercalifragilisticexpialidocious
250find_dir_prefix $objfile
251
252FIRST=1
253while [[ $# -gt 0 ]]; do
254	func_addr=$1
255	shift
256
257	# print any matches found
258	DONE=0
259	__faddr2line $objfile $func_addr $DIR_PREFIX 0
260
261	# if no match was found, print warnings
262	if [[ $DONE = 0 ]]; then
263		__faddr2line $objfile $func_addr $DIR_PREFIX 1
264		warn "no match for $func_addr"
265	fi
266done
267